<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: xoev-profil.ndr.sch 7434 2017-08-24 11:06:25Z fbuettner $ -->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" queryBinding="xslt2">
    <sch:title>Allgemeingültige KoSIT-Regeln</sch:title>
    <xsl:include href="xgenerator-library.xgen-core.xsl"/>
    <xsl:include href="xgenerator-library.uml-access-layer.xsl"/>
    <xsl:include href="xoev-profil.profile-access-layer.xsl"/>
    <xsl:include href="xoev-profil.helpers.xsl"/>
    <xsl:include href="kosit-magicdraw-profil.profile-access-layer.xsl"/>
    <sch:ns uri="http://www.xoev.de/de/xgenerator/framework/1/library" prefix="xgen"/>
    <sch:ns uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
    <sch:ns uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
    <sch:ns uri="http://www.xoev.de/de/xoev-profil/1_6_0" prefix="xoev"/>
    <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/1_16_0" prefix="kosit"/>
    <!-- Quelle XGen2-Datei: KoSIT-MUSS.invariants, KoSIT-SOLL.invariants, KoSIT-EMPFEHLUNG.invariants -->
    <!-- Umsetzungsstand: vollständig -->
    <sch:pattern>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//ownedComment[../not(uml:is-Activity(.)) and starts-with(body, '&lt;')]">
            <sch:let name="db-ns" value="'xmlns=''http://docbook.org/ns/docbook'''"/>
            <sch:let name="encapsulated-body" value="concat('&lt;section ', $db-ns, '&gt;&lt;title&gt;anonymous-section&lt;/title&gt;', body, '&lt;/section&gt;')"/>
            <sch:let name="errors" value="xgen:relaxng-instance-errors(resolve-uri(xs:anyURI('../docbookxi.rng')), $encapsulated-body)"/>
            <sch:assert role="error" id="ValidDocBookInComment" test="empty($errors)">Die Dokumentation des Elements <sch:value-of select="xgen:model-path(..)"/> ist kein valides DocBook 5: <sch:value-of select="$errors"/></sch:assert>
        </sch:rule>
    </sch:pattern>
    <!-- Quelle XGen2: MessageEnumerationIncludesAllMessages -->
    <!-- Todo MK: Prüfen und aktivieren: Nich alle nutzen kositNachrichtenEnumeration -->
    <sch:pattern id="Regel1-CodelisteNachrichtentypenEnthaeltAlleNachrichtennummern">
        <sch:title>Codeliste Nachrichtentypen enthaelt alle Nachrichtennummern</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and not(xoev:xsdDraft(.))]">
            <sch:let name="cl" value="ancestor::packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit:kositNachrichtenEnumeration(.)]"/>
            <sch:assert role="error" id="CodelisteNachrichtentypenEnthaeltAlleNachrichtennummern" test="
                    empty($cl) or (some $lit in $cl/ownedLiteral[not(xoev:xsdDraft(.))]
                        satisfies $lit/@name = tokenize(@name, '\.')[last()])">Falls nicht explizit gekennzeichnet, müssen alle Nachrichten in der Nachrichtentyp-Codeliste enthalten sein. Die Nummer der Nachricht <sch:value-of select="xgen:model-path(.)"/> ist nicht in der Codeliste enthalten.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <!-- Quelle XGen2: versionenNachrichtenkopfUndSchemaKonsistent -->
    <sch:pattern id="Regel2-VersionenNachrichtenkopfUndSchemaKonsistent">
        <sch:title>Versionen Nachrichtenkopf und Schema konsistent</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[@name != 'Nachricht.G2G' and xoev:topmost-parent(.)/@name = 'Nachricht.G2G' and ownedAttribute[@name = 'version']]">
            <sch:assert role="error" id="VersionenNachrichtenkopfUndSchemaKonsistent" test="ownedAttribute[@name = 'version']/(defaultValue/@value, defaultValue/body)[1] = (ancestor::packagedElement/xoev:xsdSchema(.)/@version, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[1]">Die Versionsangabe im Nachrichtenkopf muss mit der Versionsangabe zum Schema-Paket übereinstimmen. Der Nachrichtenkopf <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <!-- Quelle XGen2: PropertiesOfTypesAndGlobalElementsAreLocalStructuresElementsOrAttributes -->
    <sch:pattern id="Regel3-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen">
        <sch:title>Typen und globale Elemente enthalten Elemente, Attribute oder lokale Strukturen</sch:title>
        <sch:rule context="
                uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Class(.) and ownedAttribute and ancestor::packagedElement/xoev:xsdSchema(.) and not(xoev:xoevVersionCodeliste(.))] |
                uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[uml:is-Class(.) and ownedAttribute and ancestor::packagedElement/xoev:xsdSchema(.) and not(xoev:xoevVersionCodeliste(.))]">
            <sch:assert role="error" id="TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen" test="count(ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)">Alle UML-Klasseneigenschaften eines Typs oder globalen Elements müssen als xsdLocalStructure, xsdElement oder xsdAttribute gekennzeichnet sein. Eigenschaften ohne einen dieser Stereotypen sind nicht zulässig. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <!-- Quelle XGen2: CodeUndCodelisteHabenKonsistenteKennungUndVersion -->
    <sch:pattern id="Regel4-CodeUndCodelisteHabenKonsistenteKennungUndVersion">
        <sch:title>Code und Codeliste haben konsistente Kennung und Version</sch:title>
        <sch:rule context="
                uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and
                xoev:topmost-parent(.)/@name = 'Code' and ownedAttribute[@name = 'code' and uml:is-Enumeration(uml:resolve-type(.))]] |
                uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and
                xoev:topmost-parent(.)/@name = 'Code' and ownedAttribute[@name = 'code' and uml:is-Enumeration(uml:resolve-type(.))]]">
            <sch:assert role="error" id="CodeUndCodelisteHabenKonsistenteKennungUndVersion" test="
                    ownedAttribute[@name = 'listURI']/(defaultValue/@value, defaultValue/body)[1] = ownedAttribute[@name = 'code']/uml:resolve-type(.)/xoev:xoevCodeliste(.)/@kennung and
                    ownedAttribute[@name = 'listVersionID']/(defaultValue/@value, defaultValue/body)[1] = ownedAttribute[@name = 'code']/uml:resolve-type(.)/xoev:xoevVersionCodeliste(.)/@version">Bei Code-Typ 1 müssen die Kennung (listURI) und Version (listVersionID) der Kennung und Version der Codeliste (Typ des Elements "code") entsprechen. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <!-- Quelle XGen2: NachrichtLeitetVonBasisnachrichtAb -->
    <sch:pattern id="Regel5-NachrichtLeitetVonBasisnachrichtAb">
        <sch:title>Nachricht leitet von Basisnachricht ab</sch:title>
        <sch:rule context="
                uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)] |
                uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)]">
            <sch:assert role="warning" id="NachrichtLeitetVonBasisnachrichtAb" test="
                    xoev:allParents(.)[@name = 'Nachricht.G2G']">Eine Nachricht soll von der Basisnachricht 'Nachricht.G2G' ableiten. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <!-- Quelle XGen2: NoUnreferencedTypesInXsdSchemaPackage -->
    <sch:pattern id="Regel5-KeineNichtGenutztenTypenInSchemapaket">
        <sch:title>Keine nicht genutzten Typen in Schemapaket</sch:title>
        <sch:rule context="
            uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//packagedElement[uml:is-Class(.) and not(xoev:xsdDraft(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xoevVersionCodeliste(.)) and not(xoev:xoevCodeliste(.))] |
            uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//nestedClassifier[uml:is-Class(.) and not(xoev:xsdDraft(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xoevVersionCodeliste(.)) and not(xoev:xoevCodeliste(.))]">
            <sch:let name="class" value="."/>
            <sch:assert role="information" id="KeineNichtGenutztenTypenInSchemapaket" test="
                    ancestor::packagedElement[xoev:xsdXModel(.)]//ownedAttribute[uml:resolve-type(.)/@xmi:id = $class/@xmi:id] or
                    ancestor::packagedElement[xoev:xsdXModel(.)]//generalization/uml:resolve-general(.)/@xmi:id = $class/@xmi:id">Klassen aus einem xsdSchema-Paket müssen benutzt werden (entweder als Typ einer Eigenschaft oder als Basistyp einer Generalisierung). Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern id="Regel6-CodelisteNachrichtentypenKonsistentZuNachrichtennamen">
        <sch:title>Codeliste Nachrichtentypen konsistent zu Nachrichtennamen</sch:title>
        <sch:rule context="
                uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xoevCodeliste(.) and kosit:kositNachrichtenEnumeration(.)]/ownedLiteral[not(xoev:xoevCodelisteneintrag(.)/@obsolet = 'true') and not(xoev:xsdDraft(.))]">
            <sch:let name="code" value="."/>
            <sch:let name="nachricht" value="
                    $code/ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[
                    xoev:xsdMessage(.) and not(xoev:xsdDraft(.)) and tokenize(@name, '\.')[last()] = $code/@name]"/>
            <sch:assert role="error" id="CodelisteNachrichtentypenKonsistentZuNachrichtennamen" test="
                    $nachricht and $nachricht/@name = $code/xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte">Die Beschreibung eines Codes aus der Codeliste für Nachrichtentypen muss dem Namen der Nachricht entsprechen. Der Code <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. <sch:value-of select="
                        if (empty($nachricht)) then
                            concat('Es existiert keine Nachricht, deren Nummer dem Code ', $code/@name, ' entspricht.')
                        else
                            concat('Die Beschreibung des Codes lautet ', $code/xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte, '. Der Nachrichtenname lautet ', $nachricht/@name, '.')"/></sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern id="Regel7-ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraum">
        <sch:title>ErweiterungspunktNamensraumEnthaeltKorrekteVersion</sch:title>
        <sch:rule context="
                uml:Model/packagedElement[
                xoev:xsdXModel(.) and xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:kosit:standard:xinneres.xauslaender']">
            <sch:let name="erweiterungspunkt" value="//packagedElement[@name = 'AZR.Erweiterungspunkt']"/>
            <sch:let name="namensraum" value="xoev:xsdXModel(.)/@namespace"/>
            <sch:assert role="error" id="ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraum" test="starts-with($erweiterungspunkt/xoev:xsdAnyContents(.)/@namespace, $namensraum)">Der Namensraum des Erweiterungspunktes muss den XAusländer-Namensraum (mit aktueller Version) enthalten. Der XAusländer-Namensraum lautet "<sch:value-of select="$namensraum"/>". Der Erweiterungspunkt-Namensraum lautet "<sch:value-of select="$erweiterungspunkt/xoev:xsdAnyContents(.)/@namespace"/>".</sch:assert>
        </sch:rule>
    </sch:pattern>
</sch:schema>
