<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: xoev-profil.ndr.sch 7434 2017-08-24 11:06:25Z fbuettner $ -->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" queryBinding="xslt2">
        
    <sch:title>KoSIT-Genericode-Regeln</sch:title>
    <xsl:include href="xgenerator-library.xgen-core.xsl"/>
    <xsl:include href="xgenerator-library.uml-access-layer.xsl"/>
    <xsl:include href="xoev-profil.profile-access-layer.xsl"/>
    <xsl:include href="kosit-codelisten-profil.profile-access-layer.xsl"/>
    <xsl:include href="xoev-profil.helpers.xsl"/>
    
    <sch:ns uri="http://www.xoev.de/de/xgenerator/framework/1/library" prefix="xgen"/>
    <sch:ns uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
    <sch:ns uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
    <sch:ns uri="http://www.xoev.de/de/xoev-profil/1_6_0" prefix="xoev"/>
    <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/1_16_0" prefix="kosit"/>
    <sch:ns uri="http://www.xoev.de/de/kosit-zubehoer/codelisten/1_16_0" prefix="kosit-codelisten"/>
    
    <!-- Quelle XGen2-Datei: KoSIT-Codelisten.MUSS.invariants -->
    
    <!-- Umsetzungsstand: vollständig -->
    
    <!-- Quelle XGen2: MetadatenelementCodelisteNameLangMussBefuelltSein -->
    <sch:pattern id="Regel1-MetadatenelementCodelisteNameLangMussBefuelltSein">
        <sch:title>Metadatenelement xoevCodeliste/nameLang muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteNameLangMussBefuelltSein" test="xoev:xoevCodeliste(.)/@nameLang and not(xoev:xoevCodeliste(.)/@nameLang = '')">Der Name (lang) einer Codeliste muss spezifiziert sein (Eigenschaft nameLang des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteNameKurzMussBefuelltSein -->
    <sch:pattern id="Regel2-MetadatenelementCodelisteNameKurzMussBefuelltSein">
        <sch:title>Metadatenelement xoevCodeliste/nameKurz muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteNameKurzMussBefuelltSein" test="xoev:xoevCodeliste(.)/@nameKurz and not(xoev:xoevCodeliste(.)/@nameKurz = '')">Der Name (kurz) einer Codeliste muss spezifiziert sein (Eigenschaft nameKurz des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteNameTechnischMussBefuelltSein -->
    <sch:pattern id="Regel3-MetadatenelementCodelisteNameTechnischMussBefuelltSein">
        <sch:title>Metadatenelement xoevCodeliste/nameTechnisch muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteNameTechnischMussBefuelltSein" test="xoev:xoevCodeliste(.)/@nameTechnisch and not(xoev:xoevCodeliste(.)/@nameTechnisch = '')">Der Name (technisch) einer Codeliste muss spezifiziert sein (Eigenschaft nameTechnisch des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteKennungMussBefuelltSein -->
    <sch:pattern id="Regel4-MetadatenelementCodelisteKennungMussBefuelltSein">
        <sch:title>Metadatenelement xoevCodeliste/kennung muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteKennungMussBefuelltSein" test="xoev:xoevCodeliste(.)/@kennung and not(xoev:xoevCodeliste(.)/@kennung = '')">Die Kennung einer Codeliste muss spezifiziert sein (Eigenschaft kennung des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteBeschreibungMussBefuelltSein -->
    <sch:pattern id="Regel5-MetadatenelementCodelisteBeschreibungMussBefuelltSein">
        <sch:title>Metadatenelement xoevCodeliste/beschreibung muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteBeschreibungMussBefuelltSein" test="xoev:xoevCodeliste(.)/@beschreibung and not(xoev:xoevCodeliste(.)/@beschreibung = '')">Die Beschreibung einer Codeliste muss spezifiziert sein (Eigenschaft beschreibung des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteHerausgebernameLangMussBefuelltSein -->
    <sch:pattern id="Regel6-MetadatenelementCodelisteHerausgebernameLangMussBefuelltSein">
        <sch:title>Metadatenelement xoevCodeliste/herausgebernameLang muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteHerausgebernameLangMussBefuelltSein" test="xoev:xoevCodeliste(.)/@herausgebernameLang and not(xoev:xoevCodeliste(.)/@herausgebernameLang = '')">Der Herausgebername (lang) einer Codeliste muss spezifiziert sein (Eigenschaft herausgebernameLang des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementVersionCodelisteVersionMussBefuelltSein -->
    <sch:pattern id="Regel7-MetadatenelementVersionCodelisteVersionMussBefuelltSein">
        <sch:title>Metadatenelement xoevVersionCodeliste/version muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementVersionCodelisteVersionMussBefuelltSein" test="xoev:xoevVersionCodeliste(.)/@version and not(xoev:xoevCodeliste(.)/@version = '')">Die Version einer Codeliste muss spezifiziert sein (Eigenschaft version des Stereotyps xoevVersionCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementVersionCodelisteVersionXOEVHandbuchMussBefuelltSein -->
    <sch:pattern id="Regel8-MetadatenelementVersionCodelisteVersionXOEVHandbuchMussBefuelltSein">
        <sch:title>Metadatenelement xoevVersionCodeliste/versionXOEVHandbuch muss befüllt sein</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementVersionCodelisteVersionXOEVHandbuchMussBefuelltSein" test="xoev:xoevVersionCodeliste(.)/@versionXOEVHandbuch and not(xoev:xoevVersionCodeliste(.)/@versionXOEVHandbuch = '')">Die Version des XÖV-Handbuchs, zu dessen Regelungen die Version der Codeliste konform ist, muss spezifiziert sein (Eigenschaft versionXOEVHandbuch des Stereotyps xoevVersionCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteKennungDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="Regel9-MetadatenelementCodelisteKennungDarfNurErlaubteZeichenEnthalten">
        <sch:title>Metadatenelement xoevCodeliste/kennung darf nur erlaubte Zeichen enthalten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementVersionCodelisteKennungDarfNurErlaubteZeichenEnthalten" test="replace(xoev:xoevCodeliste(.)/@kennung, '[a-z0-9\.\-,:]', '') = ''">Die Kennung des Codeliste darf nur die Zeichen "a-z", "0-9", "-", ":" und "." enthalten (Eigenschaft kennung des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementCodelisteNameTechnischDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="Regel10-MetadatenelementCodelisteNameTechnischDarfNurErlaubteZeichenEnthalten">
        <sch:title>Metadatenelement xoevCodeliste/nameTechnisch darf nur erlaubte Zeichen enthalten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementCodelisteNameTechnischDarfNurErlaubteZeichenEnthalten" test="replace(xoev:xoevCodeliste(.)/@nameTechnisch, '[a-zA-Z0-9\.\-,:]', '') = ''">Der Name (technisch) der Codeliste darf nur die Zeichen "a-z", "A-Z", "0-9", "-", ":" und "." enthalten (Eigenschaft nameTechnisch des Stereotyps xoevCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementVersionCodelisteDatumGueltigkeitAbDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="Regel11-MetadatenelementVersionCodelisteDatumGueltigkeitAbDarfNurErlaubteZeichenEnthalten">
        <sch:title>Metadatenelement xoevVersionCodeliste/datumGueltigkeitAb darf nur erlaubte Zeichen enthalten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementVersionCodelisteDatumGueltigkeitAbDarfNurErlaubteZeichenEnthalten" test="matches(xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb,'^[0-9]{4}-[0-9]{2}-[0-9]{2}$')">Das Datum "Gültigkeit ab" der Codeliste darf nur Datumsangaben im Format JJJJ-MM-TT enthalten (Eigenschaft datumGueltigkeitAb des Stereotyps xoevVersionCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <!-- Quelle XGen2: MetadatenelementVersionCodelisteVersionDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="Regel12-MetadatenelementVersionCodelisteVersionDarfNurErlaubteZeichenEnthalten">
        <sch:title>Metadatenelement xoevVersionCodeliste/version darf nur erlaubte Zeichen enthalten</sch:title>
        <sch:rule context="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]">
            <sch:assert role="error" id="MetadatenelementVersionCodelisteVersionDarfNurErlaubteZeichenEnthalten" test="replace(xoev:xoevVersionCodeliste(.)/@version, '[a-zA-Z0-9\.\-,:]', '') = ''">Die Version der Codeliste darf nur die Zeichen "a-z", "A-Z", "0-9", "-", ":" und "." enthalten (Eigenschaft version des Stereotyps xoevVersionCodeliste). Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>
    
</sch:schema>