<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:saxon="http://saxon.sf.net/"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:schold="http://www.ascc.net/xml/schematron"
                xmlns:iso="http://purl.oclc.org/dsdl/schematron"
                xmlns:xhtml="http://www.w3.org/1999/xhtml"
                xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library"
                xmlns:xmi="http://www.omg.org/spec/XMI/20131001"
                xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML"
                xmlns:xoev="http://www.xoev.de/de/xoev-profil/1_6_0"
                xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/1_16_0"
                version="2.0"><!--Implementers: please note that overriding process-prolog or process-root is 
    the preferred method for meta-stylesheets to use where possible. -->
   <xsl:param name="archiveDirParameter"/>
   <xsl:param name="archiveNameParameter"/>
   <xsl:param name="fileNameParameter"/>
   <xsl:param name="fileDirParameter"/>
   <xsl:variable name="document-uri">
      <xsl:value-of select="document-uri(/)"/>
   </xsl:variable>
   <!--PHASES-->
   <!--PROLOG-->
   <xsl:output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
               method="xml"
               omit-xml-declaration="no"
               standalone="yes"
               indent="yes"/>
   <!--XSD TYPES FOR XSLT2-->
   <!--KEYS AND FUNCTIONS-->
   <!--DEFAULT RULES-->
   <!--MODE: SCHEMATRON-SELECT-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-select-full-path">
      <xsl:apply-templates select="." mode="schematron-get-full-path-3"/>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">
            <xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>*:</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>[namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:variable name="preceding"
                    select="count(preceding-sibling::*[local-name()=local-name(current())                                   and namespace-uri() = namespace-uri(current())])"/>
      <xsl:text>[</xsl:text>
      <xsl:value-of select="1+ $preceding"/>
      <xsl:text>]</xsl:text>
   </xsl:template>
   <xsl:template match="@*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">@<xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>@*[local-name()='</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>' and namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-2-->
   <!--This mode can be used to generate prefixed XPath for humans-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-2">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="preceding-sibling::*[name(.)=name(current())]">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-3-->
   <!--This mode can be used to generate prefixed XPath for humans 
	(Top-level element has index)-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-3">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="parent::*">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: GENERATE-ID-FROM-PATH -->
   <xsl:template match="/" mode="generate-id-from-path"/>
   <xsl:template match="text()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.text-', 1+count(preceding-sibling::text()), '-')"/>
   </xsl:template>
   <xsl:template match="comment()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.comment-', 1+count(preceding-sibling::comment()), '-')"/>
   </xsl:template>
   <xsl:template match="processing-instruction()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.processing-instruction-', 1+count(preceding-sibling::processing-instruction()), '-')"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.@', name())"/>
   </xsl:template>
   <xsl:template match="*" mode="generate-id-from-path" priority="-0.5">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:text>.</xsl:text>
      <xsl:value-of select="concat('.',name(),'-',1+count(preceding-sibling::*[name()=name(current())]),'-')"/>
   </xsl:template>
   <!--MODE: GENERATE-ID-2 -->
   <xsl:template match="/" mode="generate-id-2">U</xsl:template>
   <xsl:template match="*" mode="generate-id-2" priority="2">
      <xsl:text>U</xsl:text>
      <xsl:number level="multiple" count="*"/>
   </xsl:template>
   <xsl:template match="node()" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>n</xsl:text>
      <xsl:number count="node()"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="string-length(local-name(.))"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="translate(name(),':','.')"/>
   </xsl:template>
   <!--Strip characters-->
   <xsl:template match="text()" priority="-1"/>
   <!--SCHEMA SETUP-->
   <xsl:template match="/">
      <svrl:schematron-output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                              title="Allgemeingültige KoSIT-Regeln"
                              schemaVersion="">
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xgenerator/framework/1/library"
                                             prefix="xgen"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xoev-profil/1_6_0" prefix="xoev"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/kosit-zubehoer/1_16_0" prefix="kosit"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M11"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel1-CodelisteNachrichtentypenEnthaeltAlleNachrichtennummern</xsl:attribute>
            <xsl:attribute name="name">Codeliste Nachrichtentypen enthaelt alle Nachrichtennummern</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M12"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel2-VersionenNachrichtenkopfUndSchemaKonsistent</xsl:attribute>
            <xsl:attribute name="name">Versionen Nachrichtenkopf und Schema konsistent</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M13"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel3-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen</xsl:attribute>
            <xsl:attribute name="name">Typen und globale Elemente enthalten Elemente, Attribute oder lokale Strukturen</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M14"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel4-CodeUndCodelisteHabenKonsistenteKennungUndVersion</xsl:attribute>
            <xsl:attribute name="name">Code und Codeliste haben konsistente Kennung und Version</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M15"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel5-NachrichtLeitetVonBasisnachrichtAb</xsl:attribute>
            <xsl:attribute name="name">Nachricht leitet von Basisnachricht ab</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M16"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel5-KeineNichtGenutztenTypenInSchemapaket</xsl:attribute>
            <xsl:attribute name="name">Keine nicht genutzten Typen in Schemapaket</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M17"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel6-CodelisteNachrichtentypenKonsistentZuNachrichtennamen</xsl:attribute>
            <xsl:attribute name="name">Codeliste Nachrichtentypen konsistent zu Nachrichtennamen</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M18"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel7-ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraum</xsl:attribute>
            <xsl:attribute name="name">ErweiterungspunktNamensraumEnthaeltKorrekteVersion</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M19"/>
      </svrl:schematron-output>
   </xsl:template>
   <!--SCHEMATRON PATTERNS-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Allgemeingültige KoSIT-Regeln</svrl:text>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.xgen-core.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.uml-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.profile-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.helpers.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="kosit-magicdraw-profil.profile-access-layer.xsl"/>
   <!--PATTERN -->
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//ownedComment[../not(uml:is-Activity(.)) and starts-with(body, '&lt;')]"
                 priority="1000"
                 mode="M11">
      <xsl:variable name="db-ns" select="'xmlns=''http://docbook.org/ns/docbook'''"/>
      <xsl:variable name="encapsulated-body"
                    select="concat('&lt;section ', $db-ns, '&gt;&lt;title&gt;anonymous-section&lt;/title&gt;', body, '&lt;/section&gt;')"/>
      <xsl:variable name="errors"
                    select="xgen:relaxng-instance-errors(resolve-uri(xs:anyURI('../docbookxi.rng')), $encapsulated-body)"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="empty($errors)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="empty($errors)">
               <xsl:attribute name="id">ValidDocBookInComment</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Dokumentation des Elements <xsl:text/>
                  <xsl:value-of select="xgen:model-path(..)"/>
                  <xsl:text/> ist kein valides DocBook 5: <xsl:text/>
                  <xsl:value-of select="$errors"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M11"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M11"/>
   <xsl:template match="@*|node()" priority="-2" mode="M11">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M11"/>
   </xsl:template>
   <!--PATTERN Regel1-CodelisteNachrichtentypenEnthaeltAlleNachrichtennummernCodeliste Nachrichtentypen enthaelt alle Nachrichtennummern-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Codeliste Nachrichtentypen enthaelt alle Nachrichtennummern</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M12">
      <xsl:variable name="cl"
                    select="ancestor::packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit:kositNachrichtenEnumeration(.)]"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     empty($cl) or (some $lit in $cl/ownedLiteral[not(xoev:xsdDraft(.))]                         satisfies $lit/@name = tokenize(@name, '\.')[last()])"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="empty($cl) or (some $lit in $cl/ownedLiteral[not(xoev:xsdDraft(.))] satisfies $lit/@name = tokenize(@name, '\.')[last()])">
               <xsl:attribute name="id">CodelisteNachrichtentypenEnthaeltAlleNachrichtennummern</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Falls nicht explizit gekennzeichnet, müssen alle Nachrichten in der Nachrichtentyp-Codeliste enthalten sein. Die Nummer der Nachricht <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> ist nicht in der Codeliste enthalten.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M12"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M12"/>
   <xsl:template match="@*|node()" priority="-2" mode="M12">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M12"/>
   </xsl:template>
   <!--PATTERN Regel2-VersionenNachrichtenkopfUndSchemaKonsistentVersionen Nachrichtenkopf und Schema konsistent-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Versionen Nachrichtenkopf und Schema konsistent</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[@name != 'Nachricht.G2G' and xoev:topmost-parent(.)/@name = 'Nachricht.G2G' and ownedAttribute[@name = 'version']]"
                 priority="1000"
                 mode="M13">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="ownedAttribute[@name = 'version']/(defaultValue/@value, defaultValue/body)[1] = (ancestor::packagedElement/xoev:xsdSchema(.)/@version, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[1]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ownedAttribute[@name = 'version']/(defaultValue/@value, defaultValue/body)[1] = (ancestor::packagedElement/xoev:xsdSchema(.)/@version, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[1]">
               <xsl:attribute name="id">VersionenNachrichtenkopfUndSchemaKonsistent</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Versionsangabe im Nachrichtenkopf muss mit der Versionsangabe zum Schema-Paket übereinstimmen. Der Nachrichtenkopf <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M13"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M13"/>
   <xsl:template match="@*|node()" priority="-2" mode="M13">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M13"/>
   </xsl:template>
   <!--PATTERN Regel3-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturenTypen und globale Elemente enthalten Elemente, Attribute oder lokale Strukturen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Typen und globale Elemente enthalten Elemente, Attribute oder lokale Strukturen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Class(.) and ownedAttribute and ancestor::packagedElement/xoev:xsdSchema(.) and not(xoev:xoevVersionCodeliste(.))] |                 uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[uml:is-Class(.) and ownedAttribute and ancestor::packagedElement/xoev:xsdSchema(.) and not(xoev:xoevVersionCodeliste(.))]"
                 priority="1000"
                 mode="M14">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="count(ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count(ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)">
               <xsl:attribute name="id">TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Alle UML-Klasseneigenschaften eines Typs oder globalen Elements müssen als xsdLocalStructure, xsdElement oder xsdAttribute gekennzeichnet sein. Eigenschaften ohne einen dieser Stereotypen sind nicht zulässig. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M14"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M14"/>
   <xsl:template match="@*|node()" priority="-2" mode="M14">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M14"/>
   </xsl:template>
   <!--PATTERN Regel4-CodeUndCodelisteHabenKonsistenteKennungUndVersionCode und Codeliste haben konsistente Kennung und Version-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Code und Codeliste haben konsistente Kennung und Version</svrl:text>
   <!--RULE -->
   <xsl:template match="                 uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and                 xoev:topmost-parent(.)/@name = 'Code' and ownedAttribute[@name = 'code' and uml:is-Enumeration(uml:resolve-type(.))]] |                 uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and                 xoev:topmost-parent(.)/@name = 'Code' and ownedAttribute[@name = 'code' and uml:is-Enumeration(uml:resolve-type(.))]]"
                 priority="1000"
                 mode="M15">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     ownedAttribute[@name = 'listURI']/(defaultValue/@value, defaultValue/body)[1] = ownedAttribute[@name = 'code']/uml:resolve-type(.)/xoev:xoevCodeliste(.)/@kennung and                     ownedAttribute[@name = 'listVersionID']/(defaultValue/@value, defaultValue/body)[1] = ownedAttribute[@name = 'code']/uml:resolve-type(.)/xoev:xoevVersionCodeliste(.)/@version"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ownedAttribute[@name = 'listURI']/(defaultValue/@value, defaultValue/body)[1] = ownedAttribute[@name = 'code']/uml:resolve-type(.)/xoev:xoevCodeliste(.)/@kennung and ownedAttribute[@name = 'listVersionID']/(defaultValue/@value, defaultValue/body)[1] = ownedAttribute[@name = 'code']/uml:resolve-type(.)/xoev:xoevVersionCodeliste(.)/@version">
               <xsl:attribute name="id">CodeUndCodelisteHabenKonsistenteKennungUndVersion</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Bei Code-Typ 1 müssen die Kennung (listURI) und Version (listVersionID) der Kennung und Version der Codeliste (Typ des Elements "code") entsprechen. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M15"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M15"/>
   <xsl:template match="@*|node()" priority="-2" mode="M15">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M15"/>
   </xsl:template>
   <!--PATTERN Regel5-NachrichtLeitetVonBasisnachrichtAbNachricht leitet von Basisnachricht ab-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Nachricht leitet von Basisnachricht ab</svrl:text>
   <!--RULE -->
   <xsl:template match="                 uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)] |                 uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[not(xoev:xsdDraft(.)) and xoev:xsdMessage(.)]"
                 priority="1000"
                 mode="M16">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="                     xoev:allParents(.)[@name = 'Nachricht.G2G']"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:allParents(.)[@name = 'Nachricht.G2G']">
               <xsl:attribute name="id">NachrichtLeitetVonBasisnachrichtAb</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Eine Nachricht soll von der Basisnachricht 'Nachricht.G2G' ableiten. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M16"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M16"/>
   <xsl:template match="@*|node()" priority="-2" mode="M16">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M16"/>
   </xsl:template>
   <!--PATTERN Regel5-KeineNichtGenutztenTypenInSchemapaketKeine nicht genutzten Typen in Schemapaket-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Keine nicht genutzten Typen in Schemapaket</svrl:text>
   <!--RULE -->
   <xsl:template match="             uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//packagedElement[uml:is-Class(.) and not(xoev:xsdDraft(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xoevVersionCodeliste(.)) and not(xoev:xoevCodeliste(.))] |             uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)]//nestedClassifier[uml:is-Class(.) and not(xoev:xsdDraft(.)) and not(xoev:xsdGlobalElement(.)) and not(xoev:xoevVersionCodeliste(.)) and not(xoev:xoevCodeliste(.))]"
                 priority="1000"
                 mode="M17">
      <xsl:variable name="class" select="."/>
      <!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="                     ancestor::packagedElement[xoev:xsdXModel(.)]//ownedAttribute[uml:resolve-type(.)/@xmi:id = $class/@xmi:id] or                     ancestor::packagedElement[xoev:xsdXModel(.)]//generalization/uml:resolve-general(.)/@xmi:id = $class/@xmi:id"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ancestor::packagedElement[xoev:xsdXModel(.)]//ownedAttribute[uml:resolve-type(.)/@xmi:id = $class/@xmi:id] or ancestor::packagedElement[xoev:xsdXModel(.)]//generalization/uml:resolve-general(.)/@xmi:id = $class/@xmi:id">
               <xsl:attribute name="id">KeineNichtGenutztenTypenInSchemapaket</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Klassen aus einem xsdSchema-Paket müssen benutzt werden (entweder als Typ einer Eigenschaft oder als Basistyp einer Generalisierung). Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M17"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M17"/>
   <xsl:template match="@*|node()" priority="-2" mode="M17">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M17"/>
   </xsl:template>
   <!--PATTERN Regel6-CodelisteNachrichtentypenKonsistentZuNachrichtennamenCodeliste Nachrichtentypen konsistent zu Nachrichtennamen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Codeliste Nachrichtentypen konsistent zu Nachrichtennamen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xoevCodeliste(.) and kosit:kositNachrichtenEnumeration(.)]/ownedLiteral[not(xoev:xoevCodelisteneintrag(.)/@obsolet = 'true') and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M18">
      <xsl:variable name="code" select="."/>
      <xsl:variable name="nachricht"
                    select="                     $code/ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[                     xoev:xsdMessage(.) and not(xoev:xsdDraft(.)) and tokenize(@name, '\.')[last()] = $code/@name]"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     $nachricht and $nachricht/@name = $code/xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="$nachricht and $nachricht/@name = $code/xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte">
               <xsl:attribute name="id">CodelisteNachrichtentypenKonsistentZuNachrichtennamen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Beschreibung eines Codes aus der Codeliste für Nachrichtentypen muss dem Namen der Nachricht entsprechen. Der Code <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. <xsl:text/>
                  <xsl:value-of select="                         if (empty($nachricht)) then                             concat('Es existiert keine Nachricht, deren Nummer dem Code ', $code/@name, ' entspricht.')                         else                             concat('Die Beschreibung des Codes lautet ', $code/xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte, '. Der Nachrichtenname lautet ', $nachricht/@name, '.')"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M18"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M18"/>
   <xsl:template match="@*|node()" priority="-2" mode="M18">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M18"/>
   </xsl:template>
   <!--PATTERN Regel7-ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraumErweiterungspunktNamensraumEnthaeltKorrekteVersion-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">ErweiterungspunktNamensraumEnthaeltKorrekteVersion</svrl:text>
   <!--RULE -->
   <xsl:template match="                 uml:Model/packagedElement[                 xoev:xsdXModel(.) and xoev:xoevStandard(.)/@kennung = 'urn:xoev-de:kosit:standard:xinneres.xauslaender']"
                 priority="1000"
                 mode="M19">
      <xsl:variable name="erweiterungspunkt"
                    select="//packagedElement[@name = 'AZR.Erweiterungspunkt']"/>
      <xsl:variable name="namensraum" select="xoev:xsdXModel(.)/@namespace"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="starts-with($erweiterungspunkt/xoev:xsdAnyContents(.)/@namespace, $namensraum)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="starts-with($erweiterungspunkt/xoev:xsdAnyContents(.)/@namespace, $namensraum)">
               <xsl:attribute name="id">ErweiterungspunktNamensraumEnthaeltXAuslaenderNamensraum</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Namensraum des Erweiterungspunktes muss den XAusländer-Namensraum (mit aktueller Version) enthalten. Der XAusländer-Namensraum lautet "<xsl:text/>
                  <xsl:value-of select="$namensraum"/>
                  <xsl:text/>". Der Erweiterungspunkt-Namensraum lautet "<xsl:text/>
                  <xsl:value-of select="$erweiterungspunkt/xoev:xsdAnyContents(.)/@namespace"/>
                  <xsl:text/>".</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M19"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M19"/>
   <xsl:template match="@*|node()" priority="-2" mode="M19">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M19"/>
   </xsl:template>
</xsl:stylesheet>
