<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:saxon="http://saxon.sf.net/"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:schold="http://www.ascc.net/xml/schematron"
                xmlns:iso="http://purl.oclc.org/dsdl/schematron"
                xmlns:xhtml="http://www.w3.org/1999/xhtml"
                xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library"
                xmlns:xmi="http://www.omg.org/spec/XMI/20131001"
                xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML"
                xmlns:xoev="http://www.xoev.de/de/xoev-profil/1_6_0"
                xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/1_16_0"
                xmlns:kosit-codelisten="http://www.xoev.de/de/kosit-zubehoer/codelisten/1_16_0"
                version="2.0"><!--Implementers: please note that overriding process-prolog or process-root is 
    the preferred method for meta-stylesheets to use where possible. -->
   <xsl:param name="archiveDirParameter"/>
   <xsl:param name="archiveNameParameter"/>
   <xsl:param name="fileNameParameter"/>
   <xsl:param name="fileDirParameter"/>
   <xsl:variable name="document-uri">
      <xsl:value-of select="document-uri(/)"/>
   </xsl:variable>
   <!--PHASES-->
   <!--PROLOG-->
   <xsl:output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
               method="xml"
               omit-xml-declaration="no"
               standalone="yes"
               indent="yes"/>
   <!--XSD TYPES FOR XSLT2-->
   <!--KEYS AND FUNCTIONS-->
   <!--DEFAULT RULES-->
   <!--MODE: SCHEMATRON-SELECT-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-select-full-path">
      <xsl:apply-templates select="." mode="schematron-get-full-path-3"/>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">
            <xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>*:</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>[namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:variable name="preceding"
                    select="count(preceding-sibling::*[local-name()=local-name(current())                                   and namespace-uri() = namespace-uri(current())])"/>
      <xsl:text>[</xsl:text>
      <xsl:value-of select="1+ $preceding"/>
      <xsl:text>]</xsl:text>
   </xsl:template>
   <xsl:template match="@*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">@<xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>@*[local-name()='</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>' and namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-2-->
   <!--This mode can be used to generate prefixed XPath for humans-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-2">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="preceding-sibling::*[name(.)=name(current())]">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-3-->
   <!--This mode can be used to generate prefixed XPath for humans 
	(Top-level element has index)-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-3">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="parent::*">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: GENERATE-ID-FROM-PATH -->
   <xsl:template match="/" mode="generate-id-from-path"/>
   <xsl:template match="text()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.text-', 1+count(preceding-sibling::text()), '-')"/>
   </xsl:template>
   <xsl:template match="comment()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.comment-', 1+count(preceding-sibling::comment()), '-')"/>
   </xsl:template>
   <xsl:template match="processing-instruction()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.processing-instruction-', 1+count(preceding-sibling::processing-instruction()), '-')"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.@', name())"/>
   </xsl:template>
   <xsl:template match="*" mode="generate-id-from-path" priority="-0.5">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:text>.</xsl:text>
      <xsl:value-of select="concat('.',name(),'-',1+count(preceding-sibling::*[name()=name(current())]),'-')"/>
   </xsl:template>
   <!--MODE: GENERATE-ID-2 -->
   <xsl:template match="/" mode="generate-id-2">U</xsl:template>
   <xsl:template match="*" mode="generate-id-2" priority="2">
      <xsl:text>U</xsl:text>
      <xsl:number level="multiple" count="*"/>
   </xsl:template>
   <xsl:template match="node()" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>n</xsl:text>
      <xsl:number count="node()"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="string-length(local-name(.))"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="translate(name(),':','.')"/>
   </xsl:template>
   <!--Strip characters-->
   <xsl:template match="text()" priority="-1"/>
   <!--SCHEMA SETUP-->
   <xsl:template match="/">
      <svrl:schematron-output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                              title="KoSIT-Genericode-Regeln"
                              schemaVersion="">
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xgenerator/framework/1/library"
                                             prefix="xgen"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xoev-profil/1_6_0" prefix="xoev"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/kosit-zubehoer/1_16_0" prefix="kosit"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/kosit-zubehoer/codelisten/1_16_0"
                                             prefix="kosit-codelisten"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel1-MetadatenelementCodelisteNameLangMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/nameLang muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M12"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel2-MetadatenelementCodelisteNameKurzMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/nameKurz muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M13"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel3-MetadatenelementCodelisteNameTechnischMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/nameTechnisch muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M14"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel4-MetadatenelementCodelisteKennungMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/kennung muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M15"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel5-MetadatenelementCodelisteBeschreibungMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/beschreibung muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M16"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel6-MetadatenelementCodelisteHerausgebernameLangMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/herausgebernameLang muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M17"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel7-MetadatenelementVersionCodelisteVersionMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevVersionCodeliste/version muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M18"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel8-MetadatenelementVersionCodelisteVersionXOEVHandbuchMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevVersionCodeliste/versionXOEVHandbuch muss befüllt sein</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M19"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel9-MetadatenelementCodelisteKennungDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/kennung darf nur erlaubte Zeichen enthalten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M20"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel10-MetadatenelementCodelisteNameTechnischDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevCodeliste/nameTechnisch darf nur erlaubte Zeichen enthalten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M21"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel11-MetadatenelementVersionCodelisteDatumGueltigkeitAbDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevVersionCodeliste/datumGueltigkeitAb darf nur erlaubte Zeichen enthalten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M22"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">Regel12-MetadatenelementVersionCodelisteVersionDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">Metadatenelement xoevVersionCodeliste/version darf nur erlaubte Zeichen enthalten</xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M23"/>
      </svrl:schematron-output>
   </xsl:template>
   <!--SCHEMATRON PATTERNS-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">KoSIT-Genericode-Regeln</svrl:text>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.xgen-core.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.uml-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.profile-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="kosit-codelisten-profil.profile-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.helpers.xsl"/>
   <!--PATTERN Regel1-MetadatenelementCodelisteNameLangMussBefuelltSeinMetadatenelement xoevCodeliste/nameLang muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/nameLang muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M12">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevCodeliste(.)/@nameLang and not(xoev:xoevCodeliste(.)/@nameLang = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevCodeliste(.)/@nameLang and not(xoev:xoevCodeliste(.)/@nameLang = '')">
               <xsl:attribute name="id">MetadatenelementCodelisteNameLangMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (lang) einer Codeliste muss spezifiziert sein (Eigenschaft nameLang des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M12"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M12"/>
   <xsl:template match="@*|node()" priority="-2" mode="M12">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M12"/>
   </xsl:template>
   <!--PATTERN Regel2-MetadatenelementCodelisteNameKurzMussBefuelltSeinMetadatenelement xoevCodeliste/nameKurz muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/nameKurz muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M13">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevCodeliste(.)/@nameKurz and not(xoev:xoevCodeliste(.)/@nameKurz = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevCodeliste(.)/@nameKurz and not(xoev:xoevCodeliste(.)/@nameKurz = '')">
               <xsl:attribute name="id">MetadatenelementCodelisteNameKurzMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (kurz) einer Codeliste muss spezifiziert sein (Eigenschaft nameKurz des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M13"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M13"/>
   <xsl:template match="@*|node()" priority="-2" mode="M13">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M13"/>
   </xsl:template>
   <!--PATTERN Regel3-MetadatenelementCodelisteNameTechnischMussBefuelltSeinMetadatenelement xoevCodeliste/nameTechnisch muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/nameTechnisch muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M14">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevCodeliste(.)/@nameTechnisch and not(xoev:xoevCodeliste(.)/@nameTechnisch = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevCodeliste(.)/@nameTechnisch and not(xoev:xoevCodeliste(.)/@nameTechnisch = '')">
               <xsl:attribute name="id">MetadatenelementCodelisteNameTechnischMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (technisch) einer Codeliste muss spezifiziert sein (Eigenschaft nameTechnisch des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M14"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M14"/>
   <xsl:template match="@*|node()" priority="-2" mode="M14">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M14"/>
   </xsl:template>
   <!--PATTERN Regel4-MetadatenelementCodelisteKennungMussBefuelltSeinMetadatenelement xoevCodeliste/kennung muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/kennung muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M15">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevCodeliste(.)/@kennung and not(xoev:xoevCodeliste(.)/@kennung = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevCodeliste(.)/@kennung and not(xoev:xoevCodeliste(.)/@kennung = '')">
               <xsl:attribute name="id">MetadatenelementCodelisteKennungMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung einer Codeliste muss spezifiziert sein (Eigenschaft kennung des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M15"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M15"/>
   <xsl:template match="@*|node()" priority="-2" mode="M15">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M15"/>
   </xsl:template>
   <!--PATTERN Regel5-MetadatenelementCodelisteBeschreibungMussBefuelltSeinMetadatenelement xoevCodeliste/beschreibung muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/beschreibung muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M16">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevCodeliste(.)/@beschreibung and not(xoev:xoevCodeliste(.)/@beschreibung = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevCodeliste(.)/@beschreibung and not(xoev:xoevCodeliste(.)/@beschreibung = '')">
               <xsl:attribute name="id">MetadatenelementCodelisteBeschreibungMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Beschreibung einer Codeliste muss spezifiziert sein (Eigenschaft beschreibung des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M16"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M16"/>
   <xsl:template match="@*|node()" priority="-2" mode="M16">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M16"/>
   </xsl:template>
   <!--PATTERN Regel6-MetadatenelementCodelisteHerausgebernameLangMussBefuelltSeinMetadatenelement xoevCodeliste/herausgebernameLang muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/herausgebernameLang muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M17">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevCodeliste(.)/@herausgebernameLang and not(xoev:xoevCodeliste(.)/@herausgebernameLang = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevCodeliste(.)/@herausgebernameLang and not(xoev:xoevCodeliste(.)/@herausgebernameLang = '')">
               <xsl:attribute name="id">MetadatenelementCodelisteHerausgebernameLangMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Herausgebername (lang) einer Codeliste muss spezifiziert sein (Eigenschaft herausgebernameLang des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M17"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M17"/>
   <xsl:template match="@*|node()" priority="-2" mode="M17">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M17"/>
   </xsl:template>
   <!--PATTERN Regel7-MetadatenelementVersionCodelisteVersionMussBefuelltSeinMetadatenelement xoevVersionCodeliste/version muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevVersionCodeliste/version muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M18">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevVersionCodeliste(.)/@version and not(xoev:xoevCodeliste(.)/@version = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevVersionCodeliste(.)/@version and not(xoev:xoevCodeliste(.)/@version = '')">
               <xsl:attribute name="id">MetadatenelementVersionCodelisteVersionMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version einer Codeliste muss spezifiziert sein (Eigenschaft version des Stereotyps xoevVersionCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M18"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M18"/>
   <xsl:template match="@*|node()" priority="-2" mode="M18">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M18"/>
   </xsl:template>
   <!--PATTERN Regel8-MetadatenelementVersionCodelisteVersionXOEVHandbuchMussBefuelltSeinMetadatenelement xoevVersionCodeliste/versionXOEVHandbuch muss befüllt sein-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevVersionCodeliste/versionXOEVHandbuch muss befüllt sein</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M19">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xoevVersionCodeliste(.)/@versionXOEVHandbuch and not(xoev:xoevVersionCodeliste(.)/@versionXOEVHandbuch = '')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xoevVersionCodeliste(.)/@versionXOEVHandbuch and not(xoev:xoevVersionCodeliste(.)/@versionXOEVHandbuch = '')">
               <xsl:attribute name="id">MetadatenelementVersionCodelisteVersionXOEVHandbuchMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version des XÖV-Handbuchs, zu dessen Regelungen die Version der Codeliste konform ist, muss spezifiziert sein (Eigenschaft versionXOEVHandbuch des Stereotyps xoevVersionCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M19"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M19"/>
   <xsl:template match="@*|node()" priority="-2" mode="M19">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M19"/>
   </xsl:template>
   <!--PATTERN Regel9-MetadatenelementCodelisteKennungDarfNurErlaubteZeichenEnthaltenMetadatenelement xoevCodeliste/kennung darf nur erlaubte Zeichen enthalten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/kennung darf nur erlaubte Zeichen enthalten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M20">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="replace(xoev:xoevCodeliste(.)/@kennung, '[a-z0-9\.\-,:]', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xoevCodeliste(.)/@kennung, '[a-z0-9\.\-,:]', '') = ''">
               <xsl:attribute name="id">MetadatenelementVersionCodelisteKennungDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung des Codeliste darf nur die Zeichen "a-z", "0-9", "-", ":" und "." enthalten (Eigenschaft kennung des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M20"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M20"/>
   <xsl:template match="@*|node()" priority="-2" mode="M20">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M20"/>
   </xsl:template>
   <!--PATTERN Regel10-MetadatenelementCodelisteNameTechnischDarfNurErlaubteZeichenEnthaltenMetadatenelement xoevCodeliste/nameTechnisch darf nur erlaubte Zeichen enthalten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevCodeliste/nameTechnisch darf nur erlaubte Zeichen enthalten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M21">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="replace(xoev:xoevCodeliste(.)/@nameTechnisch, '[a-zA-Z0-9\.\-,:]', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xoevCodeliste(.)/@nameTechnisch, '[a-zA-Z0-9\.\-,:]', '') = ''">
               <xsl:attribute name="id">MetadatenelementCodelisteNameTechnischDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (technisch) der Codeliste darf nur die Zeichen "a-z", "A-Z", "0-9", "-", ":" und "." enthalten (Eigenschaft nameTechnisch des Stereotyps xoevCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M21"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M21"/>
   <xsl:template match="@*|node()" priority="-2" mode="M21">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M21"/>
   </xsl:template>
   <!--PATTERN Regel11-MetadatenelementVersionCodelisteDatumGueltigkeitAbDarfNurErlaubteZeichenEnthaltenMetadatenelement xoevVersionCodeliste/datumGueltigkeitAb darf nur erlaubte Zeichen enthalten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevVersionCodeliste/datumGueltigkeitAb darf nur erlaubte Zeichen enthalten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M22">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="matches(xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb,'^[0-9]{4}-[0-9]{2}-[0-9]{2}$')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="matches(xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb,'^[0-9]{4}-[0-9]{2}-[0-9]{2}$')">
               <xsl:attribute name="id">MetadatenelementVersionCodelisteDatumGueltigkeitAbDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Das Datum "Gültigkeit ab" der Codeliste darf nur Datumsangaben im Format JJJJ-MM-TT enthalten (Eigenschaft datumGueltigkeitAb des Stereotyps xoevVersionCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M22"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M22"/>
   <xsl:template match="@*|node()" priority="-2" mode="M22">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M22"/>
   </xsl:template>
   <!--PATTERN Regel12-MetadatenelementVersionCodelisteVersionDarfNurErlaubteZeichenEnthaltenMetadatenelement xoevVersionCodeliste/version darf nur erlaubte Zeichen enthalten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">Metadatenelement xoevVersionCodeliste/version darf nur erlaubte Zeichen enthalten</svrl:text>
   <!--RULE -->
   <xsl:template match="uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevVersionCodeliste(.) and kosit-codelisten:kositGeneriereGenericode(.) and not(xoev:xsdDraft(.))]"
                 priority="1000"
                 mode="M23">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="replace(xoev:xoevVersionCodeliste(.)/@version, '[a-zA-Z0-9\.\-,:]', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xoevVersionCodeliste(.)/@version, '[a-zA-Z0-9\.\-,:]', '') = ''">
               <xsl:attribute name="id">MetadatenelementVersionCodelisteVersionDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version der Codeliste darf nur die Zeichen "a-z", "A-Z", "0-9", "-", ":" und "." enthalten (Eigenschaft version des Stereotyps xoevVersionCodeliste). Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M23"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M23"/>
   <xsl:template match="@*|node()" priority="-2" mode="M23">
      <xsl:apply-templates select="*|comment()|processing-instruction()" mode="M23"/>
   </xsl:template>
</xsl:stylesheet>
